'use strict';
const async = require('async');
const jsxl = require('../lib/jsxl');

//********************************************************************************************************

//TESTING

//***************************************************************************************************** 

var filter = [{ age: { $type: Number, $optional: true, $transform: (ctx, age, next) => { next(null, age * 2); }}, name: String }]

var input = [{ name: 'jane'}, { name: 'poul', age: 9 }]

var output = {
}


//console.log('------------------------');
//const e = new Error('test');
////console.log(777, e);
//e.stack = `Error: wow ${e.stack.substring(7)}`;
//e.message = `wow ${e.message}`;
//console.log(888, e.message);
//console.log(999, e);
//process.exit();


let providers = {
	aws: {
		subnets: /^[a-z_][a-z_0-9]+$/,
		regions: {
			"ap-south-2": [ 'a', 'b', 'c'],
			"us-east-1":  [ 'a', 'b', 'c'],
			"eu-west-1":  [ 'a', 'b', 'c']
		}
	}
}

let providerReference = (context, key, next) => {
	if (key in providers) return next();
	next(`is an invalid provider reference (${key})`);
};

let regionReference = (context, key, next) => {
	if (key in providers[context.context.context.key].regions) return next();
	next(`is an invalid ${context.context.context.key} region reference (${key})`);
};

let zoneReference = (context, key, next) => {
	if (providers[context.context.context.context.context.context.key].regions[context.context.context.context.context.key].includes(key)) return next();
	next(`is an invalid ${context.context.context.context.context.context.key} region ${context.context.context.context.context.key} zone reference (${key})`);
};

let subnetName = (context, key, next) => {
console.log(3333, key.match(providers[context.context.context.context.key].subnets));	
	if (key.match(providers[context.context.context.context.key].subnets)) return next();
	next(`is an invalid ${context.context.context.context.key} subnet name (${key})`);
}

let imageReference = (context, key, next) => {
	if (key in context.root.source[context.root.key].images) return next();
	next(`is an invalid image reference (${key})`);
};

filter = {
	images: {
		$: { // images
			ingress: { $optional: true, $type: {
				
			}},
			image:  {
				// port and protocol
				// software libraries
				// processes
				// os
			},
			access: { $optional: true, $type: [{ $any: [ String, RegExp ] } ]},
			egress: { $optional: true, $type: {
				
			}},
		}
	},
	stages: {
		$: {
			preconditions: { $optional: true, $type: [
				null
			]},
			providers: {
				$: { // provider references
					$key: { $filter: providerReference },
					$type: {
						$: { // region references
							$key: { $filter: regionReference},
							$type: {
								$: { // subnet sets
									$key: { $filter: subnetName },
									$type: {
										$: { // image references
											$key: { $filter: imageReference }, 
											$type: {
												zones: { $type: [ { $type: String, $length: 1, $transform: zoneReference } ], $minlen: 1 },
												count: { $type: [ Number ], $minlen: 1, $maxlen: 2 } 
											}
										}
									}
								}
							}
						}
					}
				},
			},
			tests: { $optional: true, $type: [
				null
			]},
			postconditions: { $optional: true, $type: [
				null
			]}
		}
	}
};

input = {
	images: {
		image1: {
			ingress: {},
			image: {},
			access: [],
			egress: {},
		},
		image2: {
			ingress: {},
			image: {},
			access: [],
			egress: {},
		}
	},
	stages: {
		production: {
			providers: {
				aws: {
					'us-east-1': {
						"subnetset1": {
							image1: {
								zones: ['a', 'b'], 
								count: [ 2, 6 ]
							}
						}
					},
					'eu-west-1': {
						subnetset1: {
							image1: {
								zones: ['a', 'b', 'c'], 
								count: [ 3, 9 ]
							}
						}
					}
				}
			}
		}
	}
};



filter = 
{ $parallel: false, $type: { a: Number, b: Number, c: Number }}
input = {
	a: 1,
	b: 2,
	c: 3
}


if (false) jsxl({ input }, filter, { inspect: true }, (err, out) => console.log(1234, err, out))



//const request = require("request");
//1st filter

//input = { a: { a: 5 } };
//filter = {
//		  $: { 
//				$key: { $filter: (ctx, val, next) => { next(); } },
//				$type: {
//					a: Number
//				}
//		  }
//	  }

if (false) jsxl.compile(
	filter,
	{ inspect: true },
	(err, filter) => { 
		if (err) {
			console.log(err);
			process.exit();
		}
		let n = 0;
		filter.functions.map(f => {
			console.log('--- function', n++, '---');
			console.log(f.toString());
		})
		jsxl.execute({ input }, filter, (err, result) => {
			console.log(err, JSON.stringify(result, null, 4)); // JSON.stringify(input, null, 4)
			process.exit();
		});
	}
);
if (false) jsxl(
		{ input },
		filter,
		{ inspect: true },
		(err, result) => {
			console.log(err, JSON.stringify(input, null, 2), JSON.stringify(result, null, 4));
			process.exit();
		}
	);

//***************************************************************************************************************

let computes = {
	aws: {
		'us-north-1a': {
			vpc: {
				vpc1: {
					cidr_block: '182.0.0.1/16',
					tags: {
						Name: 'john-test-vpc1',
					}
				},
				vpc2: {
					cidr_block: '182.0.0.2/16',
					tags: {
						Name: 'john-test-vpc2',
					}
				}
			}
		},
		'us-north-1b': {
			vpc: {
				vpc3: {
					cidr_block: '182.0.0.3/16',
					tags: {
						Name: 'john-test-vpc3',
					}
				}
			}
		}
	}
}

if (false) if (computes.aws)
	for (let [ regionKey, region ] of Object.entries(computes.aws)) {
		if (region.vpc)
			for (let [ vpcKey, vpc ] of Object.entries(region.vpc)) {
				console.log(regionKey, vpcKey, vpc);
			}
	}	

if (true) {
//	const { load } = require('./loader');
	filter = { a: Number, b: Number };
	input = { x: 0, y: 0 };

	//	load('./testplugins', 'plugin3', input, filter, (err, output) => {
	//		console.log(err, output);
		
//	jsxl({ input: {}}, 'Plugin', (err, output) => {
		async.each([
			'plugin1',
			'plugin2',
			'plugin2'
		], (file, next) => {
			jsxl.load(`./testplugins/${file}`, input, filter, (err, output) => {
				console.log(err, output);
				next(null, output);
			});
		}, () => {
			console.log('DONE');
		});
//	});
		
	//	});
	
}


class Box {
	name;
	
	constructor(name) {
		this.name = name;
	}
	
	get name() {
		return this.name;
	}
	
	get name2() {
		return this.name;
	}
	
	printName() {
		console.log(this.name);
	}
}

const b = new Box('james');
//console.log(1233, b['printName']);

jsxl.useFilters({
	Dummy: { $type: Number, $transform: (ctx, val, next) => setTimeout(() => next(), Math.random() * 1000)},
	Doooo: 'Dummy' 
});

//async.forEachOfSeries(b, (entry, key, next) => { console.log(3434, entry, key); next()}, console.log)

if (false)
	jsxl({ b }, { name: String }, (err, output) => console.log(err, output.name ) );

if (false)
	jsxl({ input: 0 }, { $lt: (ctx, val, next) => next(null, 7) }, console.log );


if (false) {
	async.each([1,2,3,4,5,6,7], (item, next) => jsxl({ input: item }, 'Doooo', { inspect: false }, (err, output) => {
		console.log(err, output);
		next();
	}), () => console.log('DONE'))
}
if (false) {
	async.each([1,2], (item, next) => jsxl.compile('Dummy', { inspect: true }, (err, output) => {
		console.log(err,output);
		jsxl.execute({ input: { dummy: {} } }, output, next);
//		next();
	}), () => console.log('DONE'))
}

function show(message, success, next) {
	return (err, output) => {
		console.log(output);
		if ((success && !err) || (!success && err)) console.log(message, success, 'succeeded'); else console.log(message, success, 'failed');
		next();
	}
}


let d = new Date()

//console.log(1000, d, new Date(d.getTime()));
//console.log(1234, d == new Date(d.getTime()));





if (false) async.series([
//	next => jsxl({ input: 7 }, { $lt: 9 }, show('7 < 9', true, next)),
//	next => jsxl({ input: 7 }, { $lt: 5 }, show('7 < 5', false, next)),
//
//	next => jsxl({ input: 7 }, { $lt: (ctx, val, next) => next(null, 9) }, show('7 < 9', true, next)),
//	next => jsxl({ input: 7 }, { $lt: (ctx, val, next) => next(null, 5) }, show('7 < 5', false, next)),
//	
//	next => jsxl({ input: 7 }, { $lt: '9' }, show('7 < "9"', true, next)),
//	next => jsxl({ input: 7 }, { $lt: '5' }, show('7 < "5"', false, next)),
//
//	next => jsxl({ input: 7 }, { $lt: new Date() }, show('7 < new Date()', true, next)),
//
//	next => jsxl({ input: [1, 2] }, { $lt: 3 }, show('[1, 2] < 3', false, next)),

	next => jsxl({ 
		input: { a: 7 }
	}, { 
		a: { $insert: 9 }, 
		b: { $insert: (ctx, val, next) => next(null)
	}}, { inspect: true }, show('insert success', true, next)),
	
	
	
], () => console.log('DONE'));


//input = { a: 8 };
//filter = { a: {
//	$lt: (ctx, val, next) => { next(null, 9); next(null, 9)}
//}};


// ERROR should be 1 not undfined
input = undefined;
filter = { $optional: true }


//jsxl({ input }, filter, console.log);


//const stack = [];
//
//function forProducer(type, instance, fn, next) {
//	stack.unshift({ type, instance }); console.log(stack) 
//    fn((...outputs) => {
//    	stack.shift(); 
//    	next(...outputs);
//    });
//}
//
//let next = console.log;
// 
// ((a, b, c, next) => {
//	 
//	 forProducer('x', 'y', (next) => {
//		 
//		 console.log('//do something', a, b, c);
//		 next(null, a + b + c);
//		 
//	 }, next);
//     
// })(1, 2, 3, next);
// 
//// helper function 
//#forProducer(type, instance, fn, next) {
//	this.producerStack.unshift({ type, instance }); console.log(stack) // producerStack[0] is the top 
//    fn((...args) => {
//    	this.producerStack.shift(); 
//    	next(...args);
//    });
//}
//
//// use of helper function
//this.#forProducer('type', 'instance' next => {
//	// do something
//	next();
//}, next);
//

//jsxl(
//		  {
//		    key: { a: [1, 2, 3] },
//		  },
//		  {
//		    a: {
//		      $inc: 4,
//		    },
//		  },
//		  (err, output) => {
//		    console.log(err, output);
//		  }
//		);
//



//const { spawn } = require('child_process');
//
//const runCommand = (command, args, next) => {
//    let output = '';
//    const out = spawn(command, args);
//    out.stdout.on('data', data => {
//        console.log(`${data}`);
//        output += data.toString();
//    });
//    out.stderr.on('data', data => {
//        console.log(`${data}`);
//        output += data.toString();
//    });
//    out.on('close', code => (code == 0) ? next(null, output) : next(new Error(`Command could not be executed ${code} ${output}`)));
//}
//
//
//async.series([
//	next => async.eachSeries([['/all'], ['/displaydns']], (item, next) => runCommand('ipconfig', item, next), next)
//], console.log);

